//+------------------------------------------------------------------+
//|                                                     qwert123.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Locol91"
#property link      "http://www.metaquotes.net"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  Yellow
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
//---- indicator parameters

extern int SignalSMA=1;
extern int Period_MA=5;
double FastEMA;
double SlowEMA;
//---- indicator buffers
 
double     MacdBuffer[];
double     SignalBuffer[];
double     MaBuffer[];
int i=0;
double r;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexDrawBegin(2,Period_MA);
   IndicatorDigits(Digits+2);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(2,MaBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MoD("+FastEMA+","+SlowEMA+","+SignalSMA+","+Period_MA+","+r+")");
   SetIndexLabel(0,"MoD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"MA");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double r; 
   int limit;
   int ExtCountedBars=0;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for( i=0; i<limit; i++) {
      r = MathAbs((iClose(NULL,PERIOD_M1,i) - iClose(NULL,PERIOD_M1,i+1))*10000);
      if(r>1) r=1;
      FastEMA=NormalizeDouble((9/r),0); 
      SlowEMA=NormalizeDouble((26/r),0);
      MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   }
//---- signal line counted in the 2-nd buffer

   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_LWMA,i);
   for(i=0; i<limit; i++)
        MaBuffer[i]=iMAOnArray(MacdBuffer,Bars,Period_MA,0,MODE_LWMA,i);
//+------------------------------------------------------------------+ 
      
   return (r);                            //   start()
  }
  

  